// Aufg20.cs

using System;

public abstract class Form {

	private int farbe;
	public const int ROT = 1;
	public const int GRUEN = 2;
	public const int BLAU = 4;

	public int Farbe {
		get {
			return farbe;
		}
		set {
			if (value < 8)
				farbe = value;
		}
	}

	public string FarbeToString() {
		switch(farbe) {
			case 0:
				return "schwarz";
			case 1:
				return "rot";
			case 2:
				return "grn";
			case 3:
				return "gelb";
			case 4:
				return "blau";
			case 5:
				return "magenta";
			case 6:
				return "cyan";
			case 7:
				return "wei";
			default:
				return "unbekannt";
		}
	}

	virtual public double Flaeche {
		get {
			return 0;
		}
	}

	virtual public double Umfang {
		get {
			return 0;
		}
	}
}

public class Rechteck : Form {

	private int a, b;

	public Rechteck(int a, int b) {
		this.a = a;
		this.b = b;
	}

	override public double Flaeche {
		get {
			return a*b;
		}
	}

	override public double Umfang {
		get {
			return 2*(a+b);
		}
	}
}

public class Quadrat : Rechteck {

	public Quadrat(int a) : base(a, a) {
	}
}

public class Aufg20 {	

	public static void Main() {
		Rechteck r = new Rechteck(5,2);
		Quadrat q = new Quadrat(4);
		r.Farbe = Form.GRUEN;
		q.Farbe = Form.ROT;
		Console.WriteLine(r.Flaeche);
		Console.WriteLine(r.Umfang);
		Console.WriteLine(r.FarbeToString());
		Console.WriteLine(q.Flaeche);
		Console.WriteLine(q.Umfang);
		Console.WriteLine(q.FarbeToString());
	}
}
