// Bspl042.cs

using System;

public class Konto {

	private decimal saldo;
	private string inhaber;

	public decimal Saldo {
		get {
			return saldo;
		}
	}

	public Konto(string inhaber) : this(inhaber, 0){
	}

	public Konto(string inhaber, decimal betrag) {
		this.inhaber = inhaber;
		saldo += betrag +10;
	}

	public void Einzahlen(decimal betrag){
		saldo += betrag;
	}

	public void Einzahlen(decimal betrag, string waehrung){
		if (waehrung == "EUR")
			Einzahlen(betrag * 1.95583m);
		else
			Einzahlen(betrag);
	}

	public void Einzahlen(double[] betrag){
		for (int i=0; i< betrag.Length; i++)
			Einzahlen((decimal) betrag[i]);
	}

	public void Einzahlen(params decimal[] betrag){
		for (int i=0; i< betrag.Length; i++)
			Einzahlen(betrag[i]);
	}

	public void Auszahlen(decimal betrag){
		if (saldo >= betrag)
			saldo -=betrag;
	}

	public void Auszahlen(out decimal betrag){
		betrag = saldo;
		Auszahlen(betrag);
	}

	public void Auszahlen(ref decimal betrag){
		if (saldo < betrag)
			betrag = saldo;
		Auszahlen(betrag);
	}
}

public class Bspl042 {	

	public static void Main() {
		double[] einzahlungen = {123.5, 12.85, 350};
		decimal abhebung;
		Konto konto1 = new Konto("H. Meier");
		Konto konto2 = new Konto("H. Meier", 500m);
		Console.WriteLine(konto1.Saldo);
		Console.WriteLine(konto2.Saldo);
		konto1.Einzahlen(400m);
		konto1.Einzahlen(einzahlungen);
		konto1.Einzahlen(125m, 340.5m, 1200m, 420.75m);
		konto1.Einzahlen(100m,"EUR");
		Console.WriteLine(konto1.Saldo);

		konto2.Auszahlen(out abhebung);
		Console.WriteLine(konto2.Saldo);
		Console.WriteLine(abhebung);
		konto1.Auszahlen(400m);
		Console.WriteLine(konto1.Saldo);
		abhebung = 10000m;
		konto1.Auszahlen(ref abhebung);
		Console.WriteLine(konto1.Saldo);
		Console.WriteLine(abhebung);
	}
}
