// Bspl057.cs

using System;

public class Form {

	private int farbe;
	public const int ROT = 1;
	public const int GRUEN = 2;
	public const int BLAU = 4;

	public int Farbe {
		get {
			return farbe;
		}
		set {
			if (value < 8)
				farbe = value;
		}
	}

	public string FarbeToString() {
		switch(farbe) {
			case 0:
				return "schwarz";
			case 1:
				return "rot";
			case 2:
				return "grn";
			case 3:
				return "gelb";
			case 4:
				return "blau";
			case 5:
				return "magenta";
			case 6:
				return "cyan";
			case 7:
				return "wei";
			default:
				return "unbekannt";
		}
	}
}

public class Kreis : Form {

	protected int r;

	public Kreis(int r) {
		this.r = r;
	}

	public Kreis() {}

	public double Flaeche {
		get {
			return Math.PI * Math.Pow(r,2);
		}
	}
}

public class Ring : Kreis {

	private double l;

	public Ring(int r, double l) {
		this.r = r;
		this.l = l;
	}

	new public double Flaeche {
		get {
			return base.Flaeche 
				- Math.PI * Math.Pow(l,2);
		}
	}
}

public class Bspl057 {	

	public static void Main() {
		Ring r = new Ring(10,5);
		Console.WriteLine(r.Flaeche);
		Console.WriteLine(((Kreis)r).Flaeche);
	}
}
