// Bspl066.cs

using System;

public class Konto {	// aus Bspl042.cs

	private decimal saldo;
	private string inhaber;

	public decimal Saldo {
		get {
			return saldo;
		}
	}

	public Konto(string inhaber) : this(inhaber, 0){
	}

	public Konto(string inhaber, decimal betrag) {
		this.inhaber = inhaber;
		saldo += betrag +10;
	}

	public void Einzahlen(decimal betrag){
		saldo += betrag;
	}

	public void Einzahlen(decimal betrag, string waehrung){
		if (waehrung == "EUR")
			Einzahlen(betrag * 1.95583m);
		else
			Einzahlen(betrag);
	}

	public void Einzahlen(double[] betrag){
		for (int i=0; i< betrag.Length; i++)
			Einzahlen((decimal) betrag[i]);
	}

	public void Einzahlen(params decimal[] betrag){
		for (int i=0; i< betrag.Length; i++)
			Einzahlen(betrag[i]);
	}

	public void Auszahlen(decimal betrag){
		if (saldo >= betrag)
			saldo -=betrag;
	}

	public void Auszahlen(out decimal betrag){
		betrag = saldo;
		Auszahlen(betrag);
	}

	public void Auszahlen(ref decimal betrag){
		if (saldo < betrag)
			betrag = saldo;
		Auszahlen(betrag);
	}
}

public delegate void Zahlung(decimal betrag);

public class Bspl066 {	

	public static void Main() {
		Zahlung z1, z2, z3;
		Konto k1 = new Konto("Mller",5000m);
		Konto k2 = new Konto("Meier",2000m);
		z1 = new Zahlung(k1.Einzahlen);
		z2 = new Zahlung(k2.Auszahlen);
		z3 = z2 + z1;
		z3(500m);
		Console.WriteLine(k1.Saldo);
		Console.WriteLine(k2.Saldo);
		z3 = z3 - z1;
		z3(200m);
		Console.WriteLine(k1.Saldo);
		Console.WriteLine(k2.Saldo);
	}
}
