// Bspl067.cs

using System;

public class Konto {	

	private decimal saldo;
	private string inhaber;
	private decimal minimum = 100m;

	public decimal Saldo {
		get {
			return saldo;
		}
	}

	public Konto(string inhaber, decimal betrag) {
		this.inhaber = inhaber;
		saldo = betrag;
	}

	public void Einzahlen(decimal betrag){
		saldo += betrag;
	}

	public void Auszahlen(decimal betrag){
		if (saldo >= betrag)
			saldo -=betrag;
		if (saldo <= minimum && SaldoWarnung != null)
			SaldoWarnung();
	}

	public event Zahlung SaldoWarnung;
}

public class Kunde {

	public void Reaktion() {
		Console.WriteLine("Ich berweise bald einen Betrag.");
	}
	
}

public delegate void Zahlung();

public class Bspl067 {	

	public static void Main() {
		Kunde k = new Kunde();
		Konto giro = new Konto("Schulze",3000m);
		giro.SaldoWarnung += new Zahlung(k.Reaktion);

		giro.Auszahlen(2000m);
		Console.WriteLine(giro.Saldo);
		giro.Auszahlen(500m);
		Console.WriteLine(giro.Saldo);
		giro.Auszahlen(430m);
		Console.WriteLine(giro.Saldo);
		giro.Auszahlen(50m);
		Console.WriteLine(giro.Saldo);
	}
}
